zoukankan      html  css  js  c++  java
  • hdu 3853LOOPS (概率DP)

    LOOPS

    Time Limit: 15000/5000 MS (Java/Others)    Memory Limit: 125536/65536 K (Java/Others) Total Submission(s): 2552    Accepted Submission(s): 1041

    Problem Description
    Akemi Homura is a Mahou Shoujo (Puella Magi/Magical Girl).
    Homura wants to help her friend Madoka save the world. But because of the plot of the Boss Incubator, she is trapped in a labyrinth called LOOPS.
    The planform of the LOOPS is a rectangle of R*C grids. There is a portal in each grid except the exit grid. It costs Homura 2 magic power to use a portal once. The portal in a grid G(r, c) will send Homura to the grid below G (grid(r+1, c)), the grid on the right of G (grid(r, c+1)), or even G itself at respective probability (How evil the Boss Incubator is)! At the beginning Homura is in the top left corner of the LOOPS ((1, 1)), and the exit of the labyrinth is in the bottom right corner ((R, C)). Given the probability of transmissions of each portal, your task is help poor Homura calculate the EXPECT magic power she need to escape from the LOOPS.
     
    Input
    The first line contains two integers R and C (2 <= R, C <= 1000).
    The following R lines, each contains C*3 real numbers, at 2 decimal places. Every three numbers make a group. The first, second and third number of the cth group of line r represent the probability of transportation to grid (r, c), grid (r, c+1), grid (r+1, c) of the portal in grid (r, c) respectively. Two groups of numbers are separated by 4 spaces.
    It is ensured that the sum of three numbers in each group is 1, and the second numbers of the rightmost groups are 0 (as there are no grids on the right of them) while the third numbers of the downmost groups are 0 (as there are no grids below them).
    You may ignore the last three numbers of the input data. They are printed just for looking neat.
    The answer is ensured no greater than 1000000.
    Terminal at EOF
     
    Output
    A real number at 3 decimal places (round to), representing the expect magic power Homura need to escape from the LOOPS.
     
    Sample Input
    2 2
    0.00 0.50 0.50 0.50 0.00 0.50 0.50 0.50 0.00 1.00 0.00 0.00
     
    Sample Output
    6.000
     
    Source
     
    题意:有一个r*c的格子,从格子(1,1)出发,可以保持三种姿势,留在原地,向右一步,向下一步,且给出相应的概率,每走一步消耗2的魔法值,问最后到达(r,c)平均需要多少魔法值、
     
    题解:
        我们知道概率的  E(i)=p1+p2+p3......+pn;
        对于E(ax+bk)=a*Ex+b*Ek;
    我们不妨从(r,c)出发:
            首先要明确的是: 在没有到达(r,c)之前,是不能停留的。所以
             dp[1][1]=dp[1][2]*mat[1][1][3]+dp[2][1]*mat[1][1][2];
             dp[1][1]=dp[1][1]/(1-map[1][1][0])   //除去停下来的其他概率,得到期望    
    依次这样推:
            dp[i][j]=dp[i][j+1]*mat[i][j][3]+dp[i+1][j]*mat[i][j][2];
             dp[i][j]=dp[i][j]/(1-map[i][j][0])   //除去停下来的其他概率,得到期望  
    但是由于这样从(1,1)推断,会出现将不收敛问题;
    代码:
    //#define LOCAL
    #include<stdio.h>
    #include<string.h>
    #include<stdlib.h>
    #define maxn 1001
    double dp[maxn][maxn];
    double map[maxn][maxn][3];
    
    int main()
    {
      int rr,cc;
      #ifdef LOCAL
         freopen("test.in","r",stdin);
      #endif
    
      while(scanf("%d%d",&rr,&cc)!=EOF)
      {
          for(int i=1;i<=rr;i++)
         for(int j=1;j<=cc;j++)
             scanf("%lf%lf%lf",&map[i][j][0],&map[i][j][1],&map[i][j][2]);
         memset(dp,0,sizeof(dp));
        for(int i=rr;i>0;i--)
          for(int j=cc;j>0;j--){
              if(i==rr&&j==cc)
                 continue;  //(rr,cc)这个点是出口不需要在走了,停在原地
    
              if(map[i][j][0]!=1.0)   //如果没有到终点停下来的话,题目就会误解!
            {
               dp[i][j]=dp[i][j]*map[i][j][0]+dp[i+1][j]*map[i][j][2]+dp[i][j+1]*map[i][j][1]+2;
               dp[i][j]/=(1.0-map[i][j][0]);
            }
    
          }
        printf("%.3lf
    ",dp[1][1]);
      }
    
      return 0;
    }
  • 相关阅读:
    程序员兄弟们,我们的基本素质怎么样?
    从GridView中直接导出数据到Excel文件 处理导出乱码 类型“GridView”的控件“XXXX”必须放在具有 runat=server 的窗体标记内。”的异常
    在SQLServer 2005附加SQLServer 2008数据库异常处理
    大型企业如何搭建私有云计算平台
    GIS在石油行业中的应用
    win7(windows 7)系统下安装SQL2005(SQL Server 2005)图文教程
    三维空间数据模型及结构
    oracle适配器连接不上解决方案
    单态设计模式
    java实现排序的几种方法
  • 原文地址:https://www.cnblogs.com/gongxijun/p/4035080.html
Copyright © 2011-2022 走看看